export interface SelectionStrategy {
    next(date: Date): Date;
    previous(date: Date): Date;
    getItems(date: Date): Date[];
    nextStrategy(): SelectionStrategy;
    previousStrategy(): SelectionStrategy;
    isFinal(): boolean;
    formatDate(date: Date, loacale?: any): string;
    title(date: Date, locale?: any): string;
    isEqual(a: Date, b: Date): boolean;
}
export declare abstract class BaseStrategy implements SelectionStrategy {
    protected _previousStrategy: SelectionStrategy;
    protected _nextStrategy: SelectionStrategy;
    protected _locale: any;
    protected _formattiongOptions: any;
    constructor(locale?: any);
    abstract next(date: Date): Date;
    abstract previous(date: Date): Date;
    abstract getItems(date: Date): Date[];
    setNextStrategy(strategy: SelectionStrategy): void;
    nextStrategy(): SelectionStrategy;
    setPreviousStrategy(strategy: SelectionStrategy): void;
    previousStrategy(): SelectionStrategy;
    isFinal(): boolean;
    abstract formatDate(date: Date): string;
    abstract title(date: Date): string;
    abstract isEqual(a: Date, b: Date): boolean;
    setLocale(locale: any): void;
}
export declare class YearSelectionStrategy extends BaseStrategy {
    next(selectedDate: Date): Date;
    previous(selectedDate: Date): Date;
    getItems(selectedDate: Date): Date[];
    formatDate(date: Date): string;
    title(date: Date): string;
    isEqual(a: Date, b: Date): boolean;
}
export declare class MonthSelectionStrategy extends BaseStrategy {
    next(selectedDate: Date): Date;
    previous(selectedDate: Date): Date;
    getItems(selectedDate: Date): Date[];
    formatDate(date: Date, locale?: any): string;
    title(date: Date): string;
    isEqual(a: Date, b: Date): boolean;
}
export declare class DaySelectionStrategy extends BaseStrategy {
    protected _previousStrategy: SelectionStrategy;
    protected _nextStrategy: SelectionStrategy;
    next(selectedDate: Date): Date;
    previous(selectedDate: Date): Date;
    getItems(selectedDate: Date): Date[];
    formatDate(date: Date): string;
    title(date: Date, locale?: any): string;
    isEqual(a: Date, b: Date): boolean;
}
export declare class HourSelectionStrategy extends BaseStrategy {
    protected _previousStrategy: SelectionStrategy;
    protected _nextStrategy: SelectionStrategy;
    next(selectedDate: Date): Date;
    previous(selectedDate: Date): Date;
    getItems(selectedDate: Date): Date[];
    formatDate(date: Date): string;
    title(date: Date): string;
    isEqual(a: Date, b: Date): boolean;
}
export declare class MinuteSelectionStrategy extends BaseStrategy {
    protected _previousStrategy: SelectionStrategy;
    protected _nextStrategy: SelectionStrategy;
    next(selectedDate: Date): Date;
    previous(selectedDate: Date): Date;
    getItems(selectedDate: Date): Date[];
    formatDate(date: Date): string;
    title(date: Date): string;
    isEqual(a: Date, b: Date): boolean;
}
