import Popper from 'popper.js';
import { BaseStrategy, SelectionStrategy } from './date-time-picker-strategies';
export declare class DateTimePicker {
    protected element: Element;
    protected locale: any;
    protected selectedDate: Date;
    protected textValue: string;
    protected viewedDate: Date;
    protected now: Date;
    protected currentScope: SelectionStrategy;
    protected strategies: BaseStrategy[];
    protected options: any;
    protected popper: Popper;
    protected poppedElement: HTMLElement;
    protected hideCallback: (event: any) => void;
    amPm: string;
    mode: string;
    constructor(element: Element);
    created(): void;
    protected jQueryHas(element: HTMLElement, target: HTMLElement): boolean;
    attached(): void;
    detached(): void;
    optionsChanged(newValue: any, oldValue: any): void;
    selectedDateChanged(newValue: any, oldValue: any): void;
    textValueChanged(newValue: any, oldValue: any): void;
    private initialize();
    getDaysOfWeek(): string[];
    getOptions(currentScope: SelectionStrategy, date: Date): Date[];
    getFirstDayOfWeek(date: Date): Date;
    next(): void;
    previous(): void;
    selectItem(item: Date): void;
    isSelected(date: Date): boolean;
    isDisplayed(date: Date): boolean;
    isNow(date: Date): boolean;
    showDays(): boolean;
    getLabel(item: Date): string;
    zoomOut(): void;
    formatDate(date: Date, format: string): string;
    getTitle(date: Date): string;
    getItemClasses(date: Date): string;
    toggleAmPm(): void;
    toggleMode(): void;
    addHours(hours: number): void;
    addMinutes(minutes: number): void;
    selectHours(): void;
    selectMinutes(): void;
    show(): void;
    hide(): void;
}
