System.register(["aurelia-framework", "date-fns", "popper.js", "./date-time-picker-strategies"], function (exports_1, context_1) {
    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = (this && this.__metadata) || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var __moduleName = context_1 && context_1.id;
    var aurelia_framework_1, date_fns_1, popper_js_1, date_time_picker_strategies_1, DateTimePicker;
    return {
        setters: [
            function (aurelia_framework_1_1) {
                aurelia_framework_1 = aurelia_framework_1_1;
            },
            function (date_fns_1_1) {
                date_fns_1 = date_fns_1_1;
            },
            function (popper_js_1_1) {
                popper_js_1 = popper_js_1_1;
            },
            function (date_time_picker_strategies_1_1) {
                date_time_picker_strategies_1 = date_time_picker_strategies_1_1;
            }
        ],
        execute: function () {
            DateTimePicker = (function () {
                function DateTimePicker(element) {
                    this.element = element;
                    this.options = { format: 'DD. MM. YYYY HH:mm' };
                    this.amPm = 'AM';
                    this.mode = 'date';
                    this.strategies = [
                        new date_time_picker_strategies_1.YearSelectionStrategy(),
                        new date_time_picker_strategies_1.MonthSelectionStrategy(),
                        new date_time_picker_strategies_1.DaySelectionStrategy()
                    ];
                    this.strategies.forEach(function (strategy, index, array) {
                        if (index + 1 < array.length) {
                            strategy.setNextStrategy(array[index + 1]);
                        }
                        if (index - 1 >= 0) {
                            strategy.setPreviousStrategy(array[index - 1]);
                        }
                    });
                    this.currentScope = this.strategies[this.strategies.length - 1];
                }
                DateTimePicker.prototype.created = function () {
                    this.initialize();
                };
                DateTimePicker.prototype.jQueryHas = function (element, target) {
                    return element !== target && element.contains(target);
                };
                DateTimePicker.prototype.attached = function () {
                    var reference = this.element.querySelectorAll('.datepicker-input').item(0);
                    this.poppedElement = this.element.querySelectorAll('.dropdown-menu').item(0);
                    var self = this;
                    this.hideCallback = function (event) {
                        if (self.poppedElement !== event.target &&
                            !self.jQueryHas(self.poppedElement, event.target) &&
                            reference !== event.target) {
                            self.hide();
                        }
                    };
                    document.getElementsByTagName('body').item(0).addEventListener('click', this.hideCallback);
                    this.popper = new popper_js_1.default(reference, this.poppedElement, {
                        placement: 'auto-start'
                    });
                };
                DateTimePicker.prototype.detached = function () {
                    document.getElementsByTagName('body').item(0).removeEventListener('click', this.hideCallback);
                };
                DateTimePicker.prototype.optionsChanged = function (newValue, oldValue) {
                    if (!newValue) {
                        this.options = { format: 'DD. MM. YYYY HH:mm' };
                    }
                    if (newValue !== oldValue) {
                        console.error('Not yet implemented');
                    }
                };
                DateTimePicker.prototype.selectedDateChanged = function (newValue, oldValue) {
                    if (isNaN(Date.parse(newValue)) && newValue !== null) {
                        throw new Error('Datetimepicker, model.bind must be of type Date');
                    }
                    if (!newValue) {
                        newValue = new Date();
                    }
                    if (newValue !== oldValue && newValue) {
                        this.textValue = this.formatDate(this.selectedDate, this.options.format);
                    }
                };
                DateTimePicker.prototype.textValueChanged = function (newValue, oldValue) {
                    if (newValue !== oldValue && newValue) {
                        this.selectedDate = date_fns_1.parse(newValue, this.options.format, new Date());
                    }
                };
                DateTimePicker.prototype.initialize = function () {
                    this.now = this.viewedDate = this.selectedDate = new Date();
                };
                DateTimePicker.prototype.getDaysOfWeek = function () {
                    var _this = this;
                    var firstDay = this.getFirstDayOfWeek(new Date());
                    var daysOfWeek = Array.from(new Array(7), function (_, index) { return date_fns_1.addDays(firstDay, index); })
                        .map(function (date) { return _this.formatDate(date, 'dd'); });
                    return daysOfWeek;
                };
                DateTimePicker.prototype.getOptions = function (currentScope, date) {
                    return currentScope.getItems(date);
                };
                DateTimePicker.prototype.getFirstDayOfWeek = function (date) {
                    return date_fns_1.startOfWeek(date, { weekStartsOn: 1 });
                };
                DateTimePicker.prototype.next = function () {
                    this.viewedDate = this.currentScope.next(this.viewedDate);
                };
                DateTimePicker.prototype.previous = function () {
                    this.viewedDate = this.currentScope.previous(this.viewedDate);
                };
                DateTimePicker.prototype.selectItem = function (item) {
                    this.viewedDate = item;
                    if (this.currentScope.isFinal()) {
                        this.selectedDate = item;
                    }
                    else {
                        this.currentScope = this.currentScope.nextStrategy();
                    }
                };
                DateTimePicker.prototype.isSelected = function (date) {
                    return this.currentScope.isEqual(date, this.selectedDate);
                };
                DateTimePicker.prototype.isDisplayed = function (date) {
                    return !this.currentScope.isFinal() &&
                        this.currentScope.isEqual(date, this.viewedDate);
                };
                DateTimePicker.prototype.isNow = function (date) {
                    return this.currentScope.isEqual(date, this.now);
                };
                DateTimePicker.prototype.showDays = function () {
                    return this.currentScope.isFinal();
                };
                DateTimePicker.prototype.getLabel = function (item) {
                    return this.currentScope.formatDate(item, this.locale);
                };
                DateTimePicker.prototype.zoomOut = function () {
                    var previousStrategy = this.currentScope.previousStrategy();
                    if (previousStrategy != null) {
                        this.currentScope = previousStrategy;
                        this.viewedDate = new Date(this.viewedDate);
                    }
                };
                DateTimePicker.prototype.formatDate = function (date, format) {
                    return date_fns_1.format(date, format, { locale: this.locale });
                };
                DateTimePicker.prototype.getTitle = function (date) {
                    return this.currentScope.title(date, this.locale);
                };
                DateTimePicker.prototype.getItemClasses = function (date) {
                    var classes = [];
                    if (this.isDisplayed(date)) {
                        classes.push('displayed');
                    }
                    if (this.isSelected(date)) {
                        classes.push('selected');
                    }
                    if (this.isNow(date)) {
                        classes.push('now');
                    }
                    if (this.currentScope.isFinal()) {
                        classes.push('picker-small');
                    }
                    else {
                        classes.push('picker-large');
                    }
                    return classes.join(' ');
                };
                DateTimePicker.prototype.toggleAmPm = function () {
                    if (this.amPm === 'AM') {
                        this.selectedDate = date_fns_1.addHours(this.selectedDate, 12);
                        this.amPm = 'PM';
                    }
                    else {
                        this.selectedDate = date_fns_1.addHours(this.selectedDate, -12);
                        this.amPm = 'AM';
                    }
                };
                DateTimePicker.prototype.toggleMode = function () {
                    this.mode = this.mode === 'date' ? 'time' : 'date';
                };
                DateTimePicker.prototype.addHours = function (hours) {
                    this.selectedDate = date_fns_1.addHours(this.selectedDate, hours);
                };
                DateTimePicker.prototype.addMinutes = function (minutes) {
                    this.selectedDate = date_fns_1.addMinutes(this.selectedDate, minutes);
                };
                DateTimePicker.prototype.selectHours = function () {
                    console.error('Not yet implemented');
                };
                DateTimePicker.prototype.selectMinutes = function () {
                    console.error('Not yet implemented');
                };
                DateTimePicker.prototype.show = function () {
                    this.poppedElement.style.display = '';
                };
                DateTimePicker.prototype.hide = function () {
                    this.poppedElement.style.display = 'none';
                };
                __decorate([
                    aurelia_framework_1.bindable({ defaultBindingMode: aurelia_framework_1.bindingMode.twoWay }),
                    __metadata("design:type", Date)
                ], DateTimePicker.prototype, "selectedDate", void 0);
                __decorate([
                    aurelia_framework_1.bindable({ defaultBindingMode: aurelia_framework_1.bindingMode.twoWay }),
                    __metadata("design:type", String)
                ], DateTimePicker.prototype, "textValue", void 0);
                __decorate([
                    aurelia_framework_1.bindable,
                    __metadata("design:type", Object)
                ], DateTimePicker.prototype, "options", void 0);
                DateTimePicker = __decorate([
                    aurelia_framework_1.autoinject(),
                    __metadata("design:paramtypes", [Element])
                ], DateTimePicker);
                return DateTimePicker;
            }());
            exports_1("DateTimePicker", DateTimePicker);
        }
    };
});
